Subject: Re: bug#12350: Composites identified as primes in factor.c (when HAVE_GMP)

From: Pádraig Brady <[email-masked]>
Date: Fri, 07 Sep 2012 11:59:07 +0100

On 09/07/2012 11:35 AM, Niels Möller wrote:
> Pádraig Brady<[email-masked]>  writes:
>
>> On 09/07/2012 09:43 AM, Niels Möller wrote:
>
>>> If this is an important feature, maybe one should consider bundling
>>> mini-gmp
>
>> Bundling libraries is bad if one needed to update it.
>
> mini-gmp is not an ordinary library. It's a single portable C source
> file (currently around 4000 lines) implementing a subset of the GMP API,
> and with performance only a few times slower than the real thing, for
> "small bignums". It's *intended* for bundling with applications, either
> for unconditional use, or for use as a fallback if the real gmp library
> is not available. It's never (I hope!) going to be installed in
> /usr/lib. To me, coreutil's factor seem to be close match for what it's
> intended for.
>
> That said, mini-gmp is pretty new (I wrote most of it around last
> Christmas) and I'm not aware of any application or library using it yet.
> I think the guile hackers are considering using it (for the benefit of
> applications which use guile as an extension language, but don't need
> high performance bignums).
>
> So if you decide to use it in coreutils, you'll be pioneers.
>
> It *is* used in the GMP build process, for precomputing various internal
> tables.

I can see the need when bootstrapping,
but I'd prefer if coreutils just relied on regular GMP.

That said, I see there is some push back in debian on depending on GMP.
Note expr from coreutils also uses GMP, which may sway the decision.

thanks,
Pádraig.